--      ,     LuaIndicators,   ,     .
--       , ..      :
-- NameAndSource 
-- Interval 
-- KolLines
-- Color 
-- Width

--   ,    
dofile (getWorkingFolder().."\\IndikfromOtherPeriod\\library.lua")
 -- dofile (getWorkingFolder().."\\..\\QuikRobots\\\\library.lua")

seconds_waiting_after_connect = 60
--   ,        
--   ,           ,         
--   ,    ,         
--       getWorkingFolder().."\\_time_when_connect.seconds"
--   ,      
--       seconds_waiting_after_connect  ,     

--          
arr_name_line = {}
if KolLines == 1 then
	arr_name_line [0] = ""
elseif KolLines == 3 then
	arr_name_line [0] = "_center"
	arr_name_line [1] = "_high"
	arr_name_line [2] = "_low"
else
	for i = 0, KolLines - 1 do
		arr_name_line [i] = "_line"..i
	end
end

Settings = {}
Settings.Name = NameAndSource
Settings.line = {}
for n_line = 0, KolLines-1 do
	Settings.line[#Settings.line+1] = {
										Name = NameAndSource..arr_name_line[n_line],
										Type = TYPE_LINE,
										Color = Color,
										Width = Width
										}
end

function load_all_data ()
	local hist_zap_full = "load_all_data in IndikfromOtherPeriod"

	--      
	if string.len(getWorkingFolder()) >= 45 then 
		time_when_connect = seconds_to_datetime (hist_zap_full,0)
	elseif LoadPeremFromFile (getWorkingFolder().."\\_time_when_connect") == false then
		time_when_connect = seconds_to_datetime (hist_zap_full,0).seconds - seconds_waiting_after_connect - 5 
	end
	local time_now = GetTimeKomp(" AutoLogin")
	--       seconds_waiting_after_connect ,    
	if time_now.seconds < time_when_connect.seconds + seconds_waiting_after_connect then
		message(Settings.Name..":    , ..   "..seconds_waiting_after_connect.."     : "..(time_now.seconds - time_when_connect.seconds).."<"..seconds_waiting_after_connect.." Con:"..toYYYY_MM_DD_HH_MM(hist_zap_full,time_when_connect).." Now:"..toYYYY_MM_DD_HH_MM(hist_zap_full,time_now))
		message("       ,   .")
		return false
	end
	--    
	kodbumagi = string.sub(getDataSourceInfo().sec_code,1,2).."_"
	if string.find(Settings.Name,kodbumagi) == nil then
		Settings.Name = kodbumagi..Settings.Name
	end
	size_now = getNumCandles(Settings.Name)
	for n_line = 0, KolLines-1 do
		_G["data_line_"..n_line], max_n, l = getCandlesByIndex (Settings.Name, n_line, 0, size_now)
	end
	if max_n == nil or max_n == 0 then
		message ("     "..Settings.Name.."     ")
		return false
	else
		first_svecha_vivoda = 0 --Size()-100
		max_n = max_n - 1
		max_n_prev = max_n
		--      grafic_data
		grafic_data = {}
		for i = 0, max_n do
			if data_line_0[i].doesExist == 1 then
				local YYYYMMDDHHMMSS_i = toYYYYMMDDHHMMSS(data_line_0[i].datetime)
				grafic_data[YYYYMMDDHHMMSS_i] = {}
				for n_line = 0, KolLines-1 do
					grafic_data[YYYYMMDDHHMMSS_i]["line_"..n_line] = _G["data_line_"..n_line][i].open
				end
			end
		end
		message (Settings.Name..":  : "..tostring(max_n)..".  : "..first_svecha_vivoda.."-"..Size())
		-- print_perem("grafic_data",grafic_data,100)

		--         
		to_big_YYYYMMDDHHMMSS = _G["YYYYMMDDHHMMSS_to_YYYYMMDDHHMMSS_"..Interval]

		return true
	end
	loaded_status = true
end --load_all_data

function Init()
	first_svecha_vivoda = nil
	index_prev = 0
	seconds_prev = 0
	return #Settings.line
end --Init


function OnCalculate(index)
	if index == 1 and loaded_status == nil then
		load_all_data ()
	end
	if first_svecha_vivoda == nil then
		return nil, nil, nil
	end
	--     ,    
	if index < first_svecha_vivoda then
		return nil, nil, nil
	end
	--     ,      
	if index == Size() then
		-- message(Settings.Name.."     index="..index.." "..toYYYYMMDDHHMMSS(T(index)))
		size_now = getNumCandles(Settings.Name)
		--      
		for n_line = 0, KolLines-1 do
			_G["data_line_"..n_line], max_n, l = getCandlesByIndex (Settings.Name, n_line, size_now-1, size_now-1)
		end

		--   
		if data_line_0 ~= nil and data_line_0[0] ~= nil and data_line_0[0].doesExist == 1 then
			if KolLines == 3 then
				return data_line_0[0].open, data_line_1[0].open, data_line_2[0].open
			elseif KolLines == 1 then
				return data_line_0[0].open
			elseif KolLines == 2 then
				return data_line_0[0].open, data_line_1[0].open
			end
		--     nil
		else
			if KolLines == 3 then
				return nil, nil, nil
			elseif KolLines == 1 then
				return nil
			elseif KolLines == 2 then
				return nil, nil
			end
		end
	--      ,      
	else
		if T(index) == nil then
			return nil, nil, nil
		end
		local YYYYMMDDHHMMSS = toYYYYMMDDHHMMSS(T(index))
		local big_YYYYMMDDHHMMSS = to_big_YYYYMMDDHHMMSS (YYYYMMDDHHMMSS)
		
		res = grafic_data[big_YYYYMMDDHHMMSS]

		if res ~= nil then
			if KolLines == 3 then
				return res.line_0, res.line_1, res.line_2
			elseif KolLines == 1 then
				return res.line_0
			elseif KolLines == 2 then
				return res.line_0, res.line_1
			end
		else
			-- message("index="..index.."  small "..toYYYYMMDDHHMMSS(T(index)).."   "..to_big_YYYYMMDDHHMMSS (toYYYYMMDDHHMMSS(T(index))))
			return nil, nil, nil
		end
	end
end --OnCalculate
